from rest_framework import serializers
from asset.models import Agent, Repo, Task, TaskAgent
from utils.serializer import BaseModelSerializer


class AgentSerializer(BaseModelSerializer):
    class Meta:
        model = Agent
        fields = '__all__'


class RepoSerializer(BaseModelSerializer):
    class Meta:
        model = Repo
        fields = '__all__'


class TaskSerializer(BaseModelSerializer):
    agent_ids = serializers.PrimaryKeyRelatedField(source="taskagents", many=True, read_only=True)
    status = serializers.CharField(read_only=True)
    repo_name = serializers.CharField(source="repo.name", read_only=True)

    class Meta:
        model = Task
        fields = '__all__'


class TaskAgentSerializer(BaseModelSerializer):
    status = serializers.CharField(read_only=True)
    ip = serializers.CharField(source='agent.ip', read_only=True)
    port = serializers.IntegerField(source='agent.port', read_only=True)
    username = serializers.CharField(source='agent.username', read_only=True)

    class Meta:
        model = TaskAgent
        fields = '__all__'
