import base64
import os
import uuid

from fabric.api import *
from fabric.sftp import SFTP
import logging
import time

# env.user = 'root'
# env.hosts = ['60.10.11.231']
# env.password = '1'
env.warn_only = True

# repo_content="""[BaseOS]
# name=BaseOS
# baseurl=http://40.40.10.201/nfs4-yxy/
# enabled=1
# gpgcheck=0
# priority=1
# """

config_content = """
# This file controls the state of SELinux on the system.
# SELINUX= can take one of these three values:
#     enforcing - SELinux security policy is enforced.
#     permissive - SELinux prints warnings instead of enforcing.
#     disabled - No SELinux policy is loaded.
SELINUX=disabled
# SELINUXTYPE= can take one of these three values:
#     targeted - Targeted processes are protected,
#     minimum - Modification of targeted policy. Only selected processes are protected. 
#     mls - Multi Level Security protection.
SELINUXTYPE=targeted



"""

config_realtek_driver = """
[Unit]
Description=Load Realtek drivers.
Before=network-online.target
 
[Service]
Type=simple
ExecStartPre=/usr/sbin/rmmod r8169
ExecStart=/usr/sbin/modprobe r8169
 
[Install]
WantedBy=multi-user.target

"""


local_seconfig_file_path = '/root/config'
realtek_driver_file_path = '/root/load-realtek-driver.service'
ssh_repo_file_path = '/etc/yum.repos.d/'
log_path = '/migrate.log'

# 配置日志输出到文件
logging.basicConfig(filename='fabric.log', filemode='w', level=logging.INFO)


def upload_file(lpath, remote_path):
    # 使用Connection对象连接到远程服务器
    put(lpath, remote_path, use_sudo=True, mirror_local_mode=True, mode=0o644, temp_dir="/tmp")


def run_command_1(command):
    command = command.strip()
    content = "echo" + " \"执行:[" + time.strftime(
        "%H:%M:%S") + "] ==================== " + command + " ====================\" >> " + log_path
    run(content)
    if any([command.endswith(" &"), command.endswith(" 2>&1")]):  # 有一个为true都pass
        pass
    else:
        command = command + " | tee -a " + log_path + " 2>&1"
    run(command)

def run_command_2(command):
    command = command.strip()
    content = "echo" + " \"执行:[" + time.strftime(
        "%H:%M:%S") + "] ==================== " + command + " ====================\" >> " + log_path
    run(content)
    if any([command.endswith(" &"), command.endswith(" 2>&1")]):  # 有一个为true都pass
        pass
    else:
        command = command  + " 2>&1" + " | tee -a " + log_path
    result = run(command,warn_only=True)
    result_out = result.stdout
    if "错误" in result_out:
        run(f'echo "迁移失败" >> {log_path}', warn_only=True)
        raise SystemExit("由于发现错误，程序已停止执行。")
    elif "Error:" in result_out:
        run(f'echo "迁移失败" >> {log_path}', warn_only=True)
        raise SystemExit("由于发现错误，程序已停止执行。")
    
     


def groupinstall_gnome():
    # 安装groupinstall gnome
    run_command_2('yum install -y	NetworkManager-libreswan-gnome	')
    run_command_2('yum install -y	PackageKit-command-not-found	')
    run_command_2('yum install -y	PackageKit-gtk3-module	')
    run_command_2('yum install -y	abrt-desktop	')
    run_command_2('yum install -y	at-spi2-atk	')
    run_command_2('yum install -y	at-spi2-core	')
    run_command_2('yum install -y	avahi	')
    run_command_2('yum install -y	baobab	')
    run_command_2('yum install -y	cheese	')
    run_command_2('yum install -y	compat-cheese314	')
    run_command_2('yum install -y	control-center	')
    run_command_2('yum install -y	dconf	')
    run_command_2('yum install -y	empathy	')
    run_command_2('yum install -y	eog	')
    run_command_2('yum install -y	evince	')
    run_command_2('yum install -y	evince-nautilus	')
    run_command_2('yum install -y	file-roller	')
    run_command_2('yum install -y	file-roller-nautilus	')
    run_command_2('yum install -y	firewall-config	')
    run_command_2('yum install -y	firstboot	')
    run_command_2('yum install -y	fprintd-pam	')
    run_command_2('yum install -y	gdm	')
    run_command_2('yum install -y	gedit	')
    run_command_2('yum install -y	gnome-bluetooth	')
    run_command_2('yum install -y	gnome-calculator	')
    run_command_2('yum install -y	gnome-clocks	')
    run_command_2('yum install -y	gnome-color-manager	')
    run_command_2('yum install -y	gnome-contacts	')
    run_command_2('yum install -y	gnome-dictionary	')
    run_command_2('yum install -y	gnome-disk-utility	')
    run_command_2('yum install -y	gnome-font-viewer	')
    run_command_2('yum install -y	gnome-getting-started-docs	')
    run_command_2('yum install -y	gnome-icon-theme	')
    run_command_2('yum install -y	gnome-icon-theme-extras	')
    run_command_2('yum install -y	gnome-icon-theme-symbolic	')
    run_command_2('yum install -y	gnome-packagekit	')
    run_command_2('yum install -y	gnome-packagekit-updater	')
    run_command_2('yum install -y	gnome-screenshot	')
    run_command_2('yum install -y	gnome-session	')
    run_command_2('yum install -y	gnome-session-xsession	')
    run_command_2('yum install -y	gnome-settings-daemon	')
    run_command_2('yum install -y	gnome-shell	')
    run_command_2('yum install -y	gnome-shell-extension-apps-menu	')
    run_command_2('yum install -y	gnome-shell-extension-common	')
    run_command_2('yum install -y	gnome-shell-extension-dash-to-panel	')
    run_command_2('yum install -y	gnome-shell-extension-drive-menu	')
    run_command_2('yum install -y	gnome-shell-extension-top-icons	')
    run_command_2('yum install -y	gnome-software	')
    run_command_2('yum install -y	gnome-system-log	')
    run_command_2('yum install -y	gnome-system-monitor	')
    run_command_2('yum install -y	gnome-terminal	')
    run_command_2('yum install -y	gnome-terminal-nautilus	')
    run_command_2('yum install -y	gnome-themes-standard	')
    run_command_2('yum install -y	gnome-tweak-tool	')
    run_command_2('yum install -y	gnome-user-docs	')
    run_command_2('yum install -y	gnome-weather	')
    run_command_2('yum install -y	gstreamer1-libav	')
    run_command_2('yum install -y	gucharmap	')
    run_command_2('yum install -y	gvfs-afc	')
    run_command_2('yum install -y	gvfs-afp	')
    run_command_2('yum install -y	gvfs-archive	')
    run_command_2('yum install -y	gvfs-fuse	')
    run_command_2('yum install -y	gvfs-goa	')
    run_command_2('yum install -y	gvfs-gphoto2	')
    run_command_2('yum install -y	gvfs-mtp	')
    run_command_2('yum install -y	gvfs-smb	')
    run_command_2('yum install -y	libcanberra-gtk2	')
    run_command_2('yum install -y	libcanberra-gtk3	')
    run_command_2('yum install -y	libproxy-mozjs	')
    run_command_2('yum install -y	librsvg2	')
    run_command_2('yum install -y	libsane-hpaio	')
    run_command_2('yum install -y	metacity	')
    run_command_2('yum install -y	mousetweaks	')
    run_command_2('yum install -y	nautilus	')
    run_command_2('yum install -y	nautilus-sendto	')
    run_command_2('yum install -y	nm-connection-editor	')
    run_command_2('yum install -y	orca	')
    run_command_2('yum install -y	qgnomeplatform	')
    run_command_2('yum install -y	sane-backends-drivers-scanners	')
    run_command_2('yum install -y	seahorse	')
    run_command_2('yum install -y	setroubleshoot	')
    run_command_2('yum install -y	sushi	')
    run_command_2('yum install -y	totem	')
    run_command_2('yum install -y	totem-nautilus	')
    run_command_2('yum install -y	vinagre	')
    run_command_2('yum install -y	vino	')
    run_command_2('yum install -y	xdg-desktop-portal-gtk	')
    run_command_2('yum install -y	xdg-user-dirs-gtk	')
    run_command_2('yum install -y	NetworkManager	')
    run_command_2('yum install -y	NetworkManager-ppp	')
    run_command_2('yum install -y	python-gobject-base	')
    run_command_2('yum install -y	rdma-core	')
    run_command_2('yum install -y	selinux-policy-targeted	')
    run_command_2('yum install -y	GConf2	')
    run_command_2('yum install -y	ModemManager-glib	')
    run_command_2('yum install -y	NetworkManager-glib	')
    run_command_2('yum install -y	NetworkManager-libreswan	')
    run_command_2('yum install -y	NetworkManager-wifi	')
    run_command_2('yum install -y	PackageKit	')
    run_command_2('yum install -y	PackageKit-glib	')
    run_command_2('yum install -y	PackageKit-yum	')
    run_command_2('yum install -y	abattis-cantarell-fonts	')
    run_command_2('yum install -y	abrt	')
    run_command_2('yum install -y	abrt-addon-ccpp	')
    run_command_2('yum install -y	abrt-addon-kerneloops	')
    run_command_2('yum install -y	abrt-addon-pstoreoops	')
    run_command_2('yum install -y	abrt-addon-python	')
    run_command_2('yum install -y	abrt-addon-vmcore	')
    run_command_2('yum install -y	abrt-addon-xorg	')
    run_command_2('yum install -y	abrt-dbus	')
    run_command_2('yum install -y	abrt-gui	')
    run_command_2('yum install -y	abrt-gui-libs	')
    run_command_2('yum install -y	abrt-libs	')
    run_command_2('yum install -y	abrt-python	')
    run_command_2('yum install -y	abrt-retrace-client	')
    run_command_2('yum install -y	accountsservice	')
    run_command_2('yum install -y	accountsservice-libs	')
    run_command_2('yum install -y	adwaita-cursor-theme	')
    run_command_2('yum install -y	adwaita-gtk2-theme	')
    run_command_2('yum install -y	adwaita-icon-theme	')
    run_command_2('yum install -y	adwaita-qt5	')
    run_command_2('yum install -y	appstream-data	')
    run_command_2('yum install -y	atk	')
    run_command_2('yum install -y	atkmm	')
    run_command_2('yum install -y	audit-libs-python	')
    run_command_2('yum install -y	augeas-libs	')
    run_command_2('yum install -y	avahi-glib	')
    run_command_2('yum install -y	avahi-gobject	')
    run_command_2('yum install -y	avahi-ui-gtk3	')
    run_command_2('yum install -y	bluez	')
    run_command_2('yum install -y	bolt	')
    run_command_2('yum install -y	boost-iostreams	')
    run_command_2('yum install -y	boost-random	')
    run_command_2('yum install -y	boost-system	')
    run_command_2('yum install -y	boost-thread	')
    run_command_2('yum install -y	bridge-utils	')
    run_command_2('yum install -y	brlapi	')
    run_command_2('yum install -y	brltty	')
    run_command_2('yum install -y	bzip2	')
    run_command_2('yum install -y	cairo	')
    run_command_2('yum install -y	cairo-gobject	')
    run_command_2('yum install -y	cairomm	')
    run_command_2('yum install -y	cdparanoia-libs	')
    run_command_2('yum install -y	celt051	')
    run_command_2('yum install -y	checkpolicy	')
    run_command_2('yum install -y	cheese-libs	')
    run_command_2('yum install -y	clutter	')
    run_command_2('yum install -y	clutter-gst2	')
    run_command_2('yum install -y	clutter-gst3	')
    run_command_2('yum install -y	clutter-gtk	')
    run_command_2('yum install -y	cogl	')
    run_command_2('yum install -y	color-filesystem	')
    run_command_2('yum install -y	colord	')
    run_command_2('yum install -y	colord-gtk	')
    run_command_2('yum install -y	colord-libs	')
    run_command_2('yum install -y	control-center-filesystem	')
    run_command_2('yum install -y	cups-libs	')
    run_command_2('yum install -y	cups-pk-helper	')
    run_command_2('yum install -y	cyrus-sasl	')
    run_command_2('yum install -y	cyrus-sasl-gssapi	')
    run_command_2('yum install -y	cyrus-sasl-md5	')
    run_command_2('yum install -y	cyrus-sasl-plain	')
    run_command_2('yum install -y	cyrus-sasl-scram	')
    run_command_2('yum install -y	dbus-x11	')
    run_command_2('yum install -y	dejavu-fonts-common	')
    run_command_2('yum install -y	dejavu-sans-fonts	')
    run_command_2('yum install -y	desktop-file-utils	')
    run_command_2('yum install -y	device-mapper-multipath	')
    run_command_2('yum install -y	device-mapper-multipath-libs	')
    run_command_2('yum install -y	dleyna-connector-dbus	')
    run_command_2('yum install -y	dleyna-core	')
    run_command_2('yum install -y	dleyna-server	')
    run_command_2('yum install -y	dosfstools	')
    run_command_2('yum install -y	dotconf	')
    run_command_2('yum install -y	efivar-libs	')
    run_command_2('yum install -y	elfutils	')
    run_command_2('yum install -y	elfutils-default-yama-scope	')
    run_command_2('yum install -y	emacs-filesystem	')
    run_command_2('yum install -y	enchant	')
    run_command_2('yum install -y	espeak	')
    run_command_2('yum install -y	evince-libs	')
    run_command_2('yum install -y	evolution-data-server	')
    run_command_2('yum install -y	evolution-data-server-langpacks	')
    run_command_2('yum install -y	exempi	')
    run_command_2('yum install -y	exiv2-libs	')
    run_command_2('yum install -y	farstream	')
    run_command_2('yum install -y	farstream02	')
    run_command_2('yum install -y	festival	')
    run_command_2('yum install -y	festival-freebsoft-utils	')
    run_command_2('yum install -y	festival-lib	')
    run_command_2('yum install -y	festival-speechtools-libs	')
    run_command_2('yum install -y	festvox-slt-arctic-hts	')
    run_command_2('yum install -y	fftw-libs-double	')
    run_command_2('yum install -y	firewalld-filesystem	')
    run_command_2('yum install -y	flac-libs	')
    run_command_2('yum install -y	flatpak	')
    run_command_2('yum install -y	flatpak-libs	')
    run_command_2('yum install -y	flite	')
    run_command_2('yum install -y	folks	')
    run_command_2('yum install -y	fontconfig	')
    run_command_2('yum install -y	fontpackages-filesystem	')
    run_command_2('yum install -y	fprintd	')
    run_command_2('yum install -y	freerdp-libs	')
    run_command_2('yum install -y	frei0r-plugins	')
    run_command_2('yum install -y	fribidi	')
    run_command_2('yum install -y	fros	')
    run_command_2('yum install -y	fuse	')
    run_command_2('yum install -y	fuse-libs	')
    run_command_2('yum install -y	fwupd	')
    run_command_2('yum install -y	fwupdate-efi	')
    run_command_2('yum install -y	fwupdate-libs	')
    run_command_2('yum install -y	gavl	')
    run_command_2('yum install -y	gcr	')
    run_command_2('yum install -y	gd	')
    run_command_2('yum install -y	gdb	')
    run_command_2('yum install -y	gdisk	')
    run_command_2('yum install -y	gdk-pixbuf2	')
    run_command_2('yum install -y	genisoimage	')
    run_command_2('yum install -y	geoclue2	')
    run_command_2('yum install -y	geoclue2-libs	')
    run_command_2('yum install -y	geocode-glib	')
    run_command_2('yum install -y	ghostscript	')
    run_command_2('yum install -y	ghostscript-fonts	')
    run_command_2('yum install -y	giflib	')
    run_command_2('yum install -y	gjs	')
    run_command_2('yum install -y	glibmm24	')
    run_command_2('yum install -y	glusterfs	')
    run_command_2('yum install -y	glusterfs-api	')
    run_command_2('yum install -y	glusterfs-cli	')
    run_command_2('yum install -y	glusterfs-client-xlators	')
    run_command_2('yum install -y	glusterfs-libs	')
    run_command_2('yum install -y	glx-utils	')
    run_command_2('yum install -y	gnome-abrt	')
    run_command_2('yum install -y	gnome-bluetooth-libs	')
    run_command_2('yum install -y	gnome-desktop3	')
    run_command_2('yum install -y	gnome-keyring	')
    run_command_2('yum install -y	gnome-keyring-pam	')
    run_command_2('yum install -y	gnome-menus	')
    run_command_2('yum install -y	gnome-online-accounts	')
    run_command_2('yum install -y	gnome-packagekit-common	')
    run_command_2('yum install -y	gnome-packagekit-installer	')
    run_command_2('yum install -y	gnome-shell-extension-user-theme	')
    run_command_2('yum install -y	gnome-video-effects	')
    run_command_2('yum install -y	gom	')
    run_command_2('yum install -y	google-noto-emoji-color-fonts	')
    run_command_2('yum install -y	gperftools-libs	')
    run_command_2('yum install -y	graphite2	')
    run_command_2('yum install -y	grilo	')
    run_command_2('yum install -y	grilo-plugins	')
    run_command_2('yum install -y	gsm	')
    run_command_2('yum install -y	gsound	')
    run_command_2('yum install -y	gspell	')
    run_command_2('yum install -y	gssdp	')
    run_command_2('yum install -y	gssproxy	')
    run_command_2('yum install -y	gstreamer	')
    run_command_2('yum install -y	gstreamer-plugins-bad-free	')
    run_command_2('yum install -y	gstreamer-plugins-base	')
    run_command_2('yum install -y	gstreamer-plugins-good	')
    run_command_2('yum install -y	gstreamer-tools	')
    run_command_2('yum install -y	gstreamer1	')
    run_command_2('yum install -y	gstreamer1-plugins-bad-free	')
    run_command_2('yum install -y	gstreamer1-plugins-base	')
    run_command_2('yum install -y	gstreamer1-plugins-good	')
    run_command_2('yum install -y	gstreamer1-plugins-ugly-free	')
    run_command_2('yum install -y	gtk-update-icon-cache	')
    run_command_2('yum install -y	gtk-vnc2	')
    run_command_2('yum install -y	gtk2	')
    run_command_2('yum install -y	gtk3	')
    run_command_2('yum install -y	gtkmm30	')
    run_command_2('yum install -y	gtksourceview3	')
    run_command_2('yum install -y	gucharmap-libs	')
    run_command_2('yum install -y	gupnp	')
    run_command_2('yum install -y	gupnp-av	')
    run_command_2('yum install -y	gupnp-dlna	')
    run_command_2('yum install -y	gupnp-igd	')
    run_command_2('yum install -y	gvfs	')
    run_command_2('yum install -y	gvfs-client	')
    run_command_2('yum install -y	gvnc	')
    run_command_2('yum install -y	harfbuzz	')
    run_command_2('yum install -y	harfbuzz-icu	')
    run_command_2('yum install -y	hicolor-icon-theme	')
    run_command_2('yum install -y	highcontrast-qt5	')
    run_command_2('yum install -y	hplip-common	')
    run_command_2('yum install -y	hplip-libs	')
    run_command_2('yum install -y	hunspell	')
    run_command_2('yum install -y	hunspell-en-US	')
    run_command_2('yum install -y	hyphen	')
    run_command_2('yum install -y	ibus	')
    run_command_2('yum install -y	ibus-gtk2	')
    run_command_2('yum install -y	ibus-gtk3	')
    run_command_2('yum install -y	ibus-libs	')
    run_command_2('yum install -y	ibus-setup	')
    run_command_2('yum install -y	ipset	')
    run_command_2('yum install -y	ipset-libs	')
    run_command_2('yum install -y	ipxe-roms-qemu	')
    run_command_2('yum install -y	iscsi-initiator-utils	')
    run_command_2('yum install -y	iscsi-initiator-utils-iscsiuio	')
    run_command_2('yum install -y	iso-codes	')
    run_command_2('yum install -y	jasper-libs	')
    run_command_2('yum install -y	jbigkit-libs	')
    run_command_2('yum install -y	json-glib	')
    run_command_2('yum install -y	keyutils	')
    run_command_2('yum install -y	lcms2	')
    run_command_2('yum install -y	ldns	')
    run_command_2('yum install -y	libICE	')
    run_command_2('yum install -y	libSM	')
    run_command_2('yum install -y	libX11	')
    run_command_2('yum install -y	libX11-common	')
    run_command_2('yum install -y	libXau	')
    run_command_2('yum install -y	libXcomposite	')
    run_command_2('yum install -y	libXcursor	')
    run_command_2('yum install -y	libXdamage	')
    run_command_2('yum install -y	libXdmcp	')
    run_command_2('yum install -y	libXext	')
    run_command_2('yum install -y	libXfixes	')
    run_command_2('yum install -y	libXft	')
    run_command_2('yum install -y	libXi	')
    run_command_2('yum install -y	libXinerama	')
    run_command_2('yum install -y	libXmu	')
    run_command_2('yum install -y	libXpm	')
    run_command_2('yum install -y	libXrandr	')
    run_command_2('yum install -y	libXrender	')
    run_command_2('yum install -y	libXres	')
    run_command_2('yum install -y	libXt	')
    run_command_2('yum install -y	libXtst	')
    run_command_2('yum install -y	libXv	')
    run_command_2('yum install -y	libXxf86misc	')
    run_command_2('yum install -y	libXxf86vm	')
    run_command_2('yum install -y	libao	')
    run_command_2('yum install -y	libappstream-glib	')
    run_command_2('yum install -y	libarchive	')
    run_command_2('yum install -y	libasyncns	')
    run_command_2('yum install -y	libatasmart	')
    run_command_2('yum install -y	libavc1394	')
    run_command_2('yum install -y	libbasicobjects	')
    run_command_2('yum install -y	libblockdev	')
    run_command_2('yum install -y	libblockdev-crypto	')
    run_command_2('yum install -y	libblockdev-fs	')
    run_command_2('yum install -y	libblockdev-loop	')
    run_command_2('yum install -y	libblockdev-mdraid	')
    run_command_2('yum install -y	libblockdev-part	')
    run_command_2('yum install -y	libblockdev-swap	')
    run_command_2('yum install -y	libblockdev-utils	')
    run_command_2('yum install -y	libbluray	')
    run_command_2('yum install -y	libbytesize	')
    run_command_2('yum install -y	libcacard	')
    run_command_2('yum install -y	libcanberra	')
    run_command_2('yum install -y	libcdio	')
    run_command_2('yum install -y	libcdio-paranoia	')
    run_command_2('yum install -y	libcgroup	')
    run_command_2('yum install -y	libchamplain	')
    run_command_2('yum install -y	libchamplain-gtk	')
    run_command_2('yum install -y	libcollection	')
    run_command_2('yum install -y	libdmapsharing	')
    run_command_2('yum install -y	libdv	')
    run_command_2('yum install -y	libdvdnav	')
    run_command_2('yum install -y	libdvdread	')
    run_command_2('yum install -y	libepoxy	')
    run_command_2('yum install -y	libevdev	')
    run_command_2('yum install -y	libevent	')
    run_command_2('yum install -y	libexif	')
    run_command_2('yum install -y	libfontenc	')
    run_command_2('yum install -y	libfprint	')
    run_command_2('yum install -y	libgcab1	')
    run_command_2('yum install -y	libgdata	')
    run_command_2('yum install -y	libgdither	')
    run_command_2('yum install -y	libgee	')
    run_command_2('yum install -y	libglade2	')
    run_command_2('yum install -y	libglvnd	')
    run_command_2('yum install -y	libglvnd-egl	')
    run_command_2('yum install -y	libglvnd-gles	')
    run_command_2('yum install -y	libglvnd-glx	')
    run_command_2('yum install -y	libgnomekbd	')
    run_command_2('yum install -y	libgovirt	')
    run_command_2('yum install -y	libgphoto2	')
    run_command_2('yum install -y	libgsf	')
    run_command_2('yum install -y	libgtop2	')
    run_command_2('yum install -y	libgusb	')
    run_command_2('yum install -y	libgweather	')
    run_command_2('yum install -y	libgxps	')
    run_command_2('yum install -y	libibverbs	')
    run_command_2('yum install -y	libical	')
    run_command_2('yum install -y	libicu	')
    run_command_2('yum install -y	libiec61883	')
    run_command_2('yum install -y	libieee1284	')
    run_command_2('yum install -y	libimobiledevice	')
    run_command_2('yum install -y	libini_config	')
    run_command_2('yum install -y	libinput	')
    run_command_2('yum install -y	libiptcdata	')
    run_command_2('yum install -y	libiscsi	')
    run_command_2('yum install -y	libjpeg-turbo	')
    run_command_2('yum install -y	libldb	')
    run_command_2('yum install -y	liblouis	')
    run_command_2('yum install -y	liblouis-python	')
    run_command_2('yum install -y	libmediaart	')
    run_command_2('yum install -y	libmpc	')
    run_command_2('yum install -y	libmpcdec	')
    run_command_2('yum install -y	libmtp	')
    run_command_2('yum install -y	libmusicbrainz5	')
    run_command_2('yum install -y	libnfsidmap	')
    run_command_2('yum install -y	libnice	')
    run_command_2('yum install -y	libnl	')
    run_command_2('yum install -y	libnm-gtk	')
    run_command_2('yum install -y	libnma	')
    run_command_2('yum install -y	libnotify	')
    run_command_2('yum install -y	liboauth	')
    run_command_2('yum install -y	libofa	')
    run_command_2('yum install -y	libogg	')
    run_command_2('yum install -y	libosinfo	')
    run_command_2('yum install -y	libpath_utils	')
    run_command_2('yum install -y	libpeas	')
    run_command_2('yum install -y	libpeas-gtk	')
    run_command_2('yum install -y	libpeas-loader-python	')
    run_command_2('yum install -y	libplist	')
    run_command_2('yum install -y	libpng	')
    run_command_2('yum install -y	libpurple	')
    run_command_2('yum install -y	librados2	')
    run_command_2('yum install -y	libraw1394	')
    run_command_2('yum install -y	librbd1	')
    run_command_2('yum install -y	librdmacm	')
    run_command_2('yum install -y	libref_array	')
    run_command_2('yum install -y	libreport	')
    run_command_2('yum install -y	libreport-centos	')
    run_command_2('yum install -y	libreport-cli	')
    run_command_2('yum install -y	libreport-filesystem	')
    run_command_2('yum install -y	libreport-gtk	')
    run_command_2('yum install -y	libreport-plugin-mantisbt	')
    run_command_2('yum install -y	libreport-plugin-reportuploader	')
    run_command_2('yum install -y	libreport-plugin-rhtsupport	')
    run_command_2('yum install -y	libreport-plugin-ureport	')
    run_command_2('yum install -y	libreport-python	')
    run_command_2('yum install -y	libreport-web	')
    run_command_2('yum install -y	libreswan	')
    run_command_2('yum install -y	libseccomp	')
    run_command_2('yum install -y	libsecret	')
    run_command_2('yum install -y	libsemanage-python	')
    run_command_2('yum install -y	libshout	')
    run_command_2('yum install -y	libsigc++20	')
    run_command_2('yum install -y	libsmbclient	')
    run_command_2('yum install -y	libsmbios	')
    run_command_2('yum install -y	libsndfile	')
    run_command_2('yum install -y	libspectre	')
    run_command_2('yum install -y	libsrtp	')
    run_command_2('yum install -y	libtalloc	')
    run_command_2('yum install -y	libtar	')
    run_command_2('yum install -y	libtdb	')
    run_command_2('yum install -y	libtevent	')
    run_command_2('yum install -y	libthai	')
    run_command_2('yum install -y	libtheora	')
    run_command_2('yum install -y	libtiff	')
    run_command_2('yum install -y	libtirpc	')
    run_command_2('yum install -y	libtool-ltdl	')
    run_command_2('yum install -y	libudisks2	')
    run_command_2('yum install -y	libusal	')
    run_command_2('yum install -y	libusbmuxd	')
    run_command_2('yum install -y	libusbx	')
    run_command_2('yum install -y	libv4l	')
    run_command_2('yum install -y	libverto-tevent	')
    run_command_2('yum install -y	libvirt-daemon	')
    run_command_2('yum install -y	libvirt-gconfig	')
    run_command_2('yum install -y	libvirt-glib	')
    run_command_2('yum install -y	libvirt-gobject	')
    run_command_2('yum install -y	libvirt-libs	')
    run_command_2('yum install -y	libvisual	')
    run_command_2('yum install -y	libvorbis	')
    run_command_2('yum install -y	libvpx	')
    run_command_2('yum install -y	libwacom	')
    run_command_2('yum install -y	libwacom-data	')
    run_command_2('yum install -y	libwayland-client	')
    run_command_2('yum install -y	libwayland-cursor	')
    run_command_2('yum install -y	libwayland-egl	')
    run_command_2('yum install -y	libwayland-server	')
    run_command_2('yum install -y	libwbclient	')
    run_command_2('yum install -y	libwebp	')
    run_command_2('yum install -y	libwnck3	')
    run_command_2('yum install -y	libxcb	')
    run_command_2('yum install -y	libxkbcommon	')
    run_command_2('yum install -y	libxkbcommon-x11	')
    run_command_2('yum install -y	libxkbfile	')
    run_command_2('yum install -y	libxklavier	')
    run_command_2('yum install -y	libxml2-python	')
    run_command_2('yum install -y	libxshmfence	')
    run_command_2('yum install -y	libxslt	')
    run_command_2('yum install -y	llvm-private	')
    run_command_2('yum install -y	lockdev	')
    run_command_2('yum install -y	lz4	')
    run_command_2('yum install -y	lzop	')
    run_command_2('yum install -y	mdadm	')
    run_command_2('yum install -y	meanwhile	')
    run_command_2('yum install -y	mesa-dri-drivers	')
    run_command_2('yum install -y	mesa-filesystem	')
    run_command_2('yum install -y	mesa-libEGL	')
    run_command_2('yum install -y	mesa-libGL	')
    run_command_2('yum install -y	mesa-libgbm	')
    run_command_2('yum install -y	mesa-libglapi	')
    run_command_2('yum install -y	mobile-broadband-provider-info	')
    run_command_2('yum install -y	mokutil	')
    run_command_2('yum install -y	mozjs52	')
    run_command_2('yum install -y	mpfr	')
    run_command_2('yum install -y	mpg123-libs	')
    run_command_2('yum install -y	mtdev	')
    run_command_2('yum install -y	mtools	')
    run_command_2('yum install -y	mutter	')
    run_command_2('yum install -y	nautilus-extensions	')
    run_command_2('yum install -y	ncompress	')
    run_command_2('yum install -y	neon	')
    run_command_2('yum install -y	net-snmp-libs	')
    run_command_2('yum install -y	netcf-libs	')
    run_command_2('yum install -y	nfs-utils	')
    run_command_2('yum install -y	nmap-ncat	')
    run_command_2('yum install -y	numad	')
    run_command_2('yum install -y	openjpeg-libs	')
    run_command_2('yum install -y	opus	')
    run_command_2('yum install -y	orc	')
    run_command_2('yum install -y	osinfo-db	')
    run_command_2('yum install -y	osinfo-db-tools	')
    run_command_2('yum install -y	pakchois	')
    run_command_2('yum install -y	pango	')
    run_command_2('yum install -y	pangomm	')
    run_command_2('yum install -y	pciutils	')
    run_command_2('yum install -y	pcre2	')
    run_command_2('yum install -y	pcre2-utf16	')
    run_command_2('yum install -y	perl	')
    run_command_2('yum install -y	perl-Carp	')
    run_command_2('yum install -y	perl-Encode	')
    run_command_2('yum install -y	perl-Exporter	')
    run_command_2('yum install -y	perl-File-Path	')
    run_command_2('yum install -y	perl-File-Temp	')
    run_command_2('yum install -y	perl-Filter	')
    run_command_2('yum install -y	perl-Getopt-Long	')
    run_command_2('yum install -y	perl-HTTP-Tiny	')
    run_command_2('yum install -y	perl-PathTools	')
    run_command_2('yum install -y	perl-Pod-Escapes	')
    run_command_2('yum install -y	perl-Pod-Perldoc	')
    run_command_2('yum install -y	perl-Pod-Simple	')
    run_command_2('yum install -y	perl-Pod-Usage	')
    run_command_2('yum install -y	perl-Scalar-List-Utils	')
    run_command_2('yum install -y	perl-Socket	')
    run_command_2('yum install -y	perl-Storable	')
    run_command_2('yum install -y	perl-Text-ParseWords	')
    run_command_2('yum install -y	perl-Time-HiRes	')
    run_command_2('yum install -y	perl-Time-Local	')
    run_command_2('yum install -y	perl-constant	')
    run_command_2('yum install -y	perl-libs	')
    run_command_2('yum install -y	perl-macros	')
    run_command_2('yum install -y	perl-parent	')
    run_command_2('yum install -y	perl-podlators	')
    run_command_2('yum install -y	perl-threads	')
    run_command_2('yum install -y	perl-threads-shared	')
    run_command_2('yum install -y	pinentry-gtk	')
    run_command_2('yum install -y	pixman	')
    run_command_2('yum install -y	policycoreutils-python	')
    run_command_2('yum install -y	poppler	')
    run_command_2('yum install -y	poppler-data	')
    run_command_2('yum install -y	poppler-glib	')
    run_command_2('yum install -y	psmisc	')
    run_command_2('yum install -y	pulseaudio	')
    run_command_2('yum install -y	pulseaudio-gdm-hooks	')
    run_command_2('yum install -y	pulseaudio-libs	')
    run_command_2('yum install -y	pulseaudio-libs-glib2	')
    run_command_2('yum install -y	pulseaudio-module-bluetooth	')
    run_command_2('yum install -y	pycairo	')
    run_command_2('yum install -y	pygobject2	')
    run_command_2('yum install -y	pygtk2	')
    run_command_2('yum install -y	pygtk2-libglade	')
    run_command_2('yum install -y	python-IPy	')
    run_command_2('yum install -y	python-augeas	')
    run_command_2('yum install -y	python-brlapi	')
    run_command_2('yum install -y	python-ethtool	')
    run_command_2('yum install -y	python-firewall	')
    run_command_2('yum install -y	python-gobject	')
    run_command_2('yum install -y	python-inotify	')
    run_command_2('yum install -y	python-meh	')
    run_command_2('yum install -y	python-six	')
    run_command_2('yum install -y	python2-futures	')
    run_command_2('yum install -y	python2-pyatspi	')
    run_command_2('yum install -y	qemu-img	')
    run_command_2('yum install -y	qemu-kvm	')
    run_command_2('yum install -y	qemu-kvm-common	')
    run_command_2('yum install -y	qt5-qtbase	')
    run_command_2('yum install -y	qt5-qtbase-common	')
    run_command_2('yum install -y	qt5-qtbase-gui	')
    run_command_2('yum install -y	quota	')
    run_command_2('yum install -y	quota-nls	')
    run_command_2('yum install -y	radvd	')
    run_command_2('yum install -y	redhat-menus	')
    run_command_2('yum install -y	rest	')
    run_command_2('yum install -y	rpcbind	')
    run_command_2('yum install -y	rtkit	')
    run_command_2('yum install -y	samba-client-libs	')
    run_command_2('yum install -y	samba-common	')
    run_command_2('yum install -y	samba-common-libs	')
    run_command_2('yum install -y	sane-backends	')
    run_command_2('yum install -y	sane-backends-libs	')
    run_command_2('yum install -y	satyr	')
    run_command_2('yum install -y	sbc	')
    run_command_2('yum install -y	seabios-bin	')
    run_command_2('yum install -y	seavgabios-bin	')
    run_command_2('yum install -y	setools-libs	')
    run_command_2('yum install -y	setroubleshoot-plugins	')
    run_command_2('yum install -y	setroubleshoot-server	')
    run_command_2('yum install -y	sgabios-bin	')
    run_command_2('yum install -y	shim-x64	')
    run_command_2('yum install -y	sos	')
    run_command_2('yum install -y	sound-theme-freedesktop	')
    run_command_2('yum install -y	soundtouch	')
    run_command_2('yum install -y	sox	')
    run_command_2('yum install -y	speech-dispatcher	')
    run_command_2('yum install -y	speech-dispatcher-python	')
    run_command_2('yum install -y	speex	')
    run_command_2('yum install -y	spice-glib	')
    run_command_2('yum install -y	spice-gtk3	')
    run_command_2('yum install -y	spice-server	')
    run_command_2('yum install -y	startup-notification	')
    run_command_2('yum install -y	systemd-python	')
    run_command_2('yum install -y	taglib	')
    run_command_2('yum install -y	tcp_wrappers	')
    run_command_2('yum install -y	telepathy-farstream	')
    run_command_2('yum install -y	telepathy-filesystem	')
    run_command_2('yum install -y	telepathy-gabble	')
    run_command_2('yum install -y	telepathy-glib	')
    run_command_2('yum install -y	telepathy-haze	')
    run_command_2('yum install -y	telepathy-logger	')
    run_command_2('yum install -y	telepathy-mission-control	')
    run_command_2('yum install -y	telepathy-salut	')
    run_command_2('yum install -y	totem-pl-parser	')
    run_command_2('yum install -y	tracker	')
    run_command_2('yum install -y	udisks2	')
    run_command_2('yum install -y	unbound-libs	')
    run_command_2('yum install -y	unzip	')
    run_command_2('yum install -y	upower	')
    run_command_2('yum install -y	urw-fonts	')
    run_command_2('yum install -y	usbmuxd	')
    run_command_2('yum install -y	usbredir	')
    run_command_2('yum install -y	userspace-rcu	')
    run_command_2('yum install -y	volume_key-libs	')
    run_command_2('yum install -y	vte-profile	')
    run_command_2('yum install -y	vte291	')
    run_command_2('yum install -y	wavpack	')
    run_command_2('yum install -y	webkitgtk3	')
    run_command_2('yum install -y	webkitgtk4	')
    run_command_2('yum install -y	webkitgtk4-jsc	')
    run_command_2('yum install -y	webkitgtk4-plugin-process-gtk2	')
    run_command_2('yum install -y	webrtc-audio-processing	')
    run_command_2('yum install -y	xcb-util	')
    run_command_2('yum install -y	xcb-util-image	')
    run_command_2('yum install -y	xcb-util-keysyms	')
    run_command_2('yum install -y	xcb-util-renderutil	')
    run_command_2('yum install -y	xcb-util-wm	')
    run_command_2('yum install -y	xdg-desktop-portal	')
    run_command_2('yum install -y	xdg-user-dirs	')
    run_command_2('yum install -y	xdg-utils	')
    run_command_2('yum install -y	xkeyboard-config	')
    run_command_2('yum install -y	xml-common	')
    run_command_2('yum install -y	xmlrpc-c	')
    run_command_2('yum install -y	xmlrpc-c-client	')
    run_command_2('yum install -y	xorg-x11-font-utils	')
    run_command_2('yum install -y	xorg-x11-server-utils	')
    run_command_2('yum install -y	xorg-x11-xauth	')
    run_command_2('yum install -y	xorg-x11-xinit	')
    run_command_2('yum install -y	xorg-x11-xkb-utils	')
    run_command_2('yum install -y	yajl	')
    run_command_2('yum install -y	zenity	')
    run_command_2('yum install -y	zip	')
    run_command_2('yum install -y	NetworkManager-libnm	')
    run_command_2('yum install -y	NetworkManager-team	')
    run_command_2('yum install -y	NetworkManager-tui	')
    run_command_2('yum install -y	audit	')
    run_command_2('yum install -y	audit-libs	')
    run_command_2('yum install -y	avahi-autoipd	')
    run_command_2('yum install -y	avahi-libs	')
    run_command_2('yum install -y	bzip2-libs	')
    run_command_2('yum install -y	cryptsetup-libs	')
    run_command_2('yum install -y	cyrus-sasl-lib	')
    run_command_2('yum install -y	dbus	')
    run_command_2('yum install -y	dbus-libs	')
    run_command_2('yum install -y	device-mapper	')
    run_command_2('yum install -y	device-mapper-event	')
    run_command_2('yum install -y	device-mapper-event-libs	')
    run_command_2('yum install -y	device-mapper-libs	')
    run_command_2('yum install -y	device-mapper-persistent-data	')
    run_command_2('yum install -y	elfutils-libelf	')
    run_command_2('yum install -y	elfutils-libs	')
    run_command_2('yum install -y	firewalld	')
    run_command_2('yum install -y	freetype	')
    run_command_2('yum install -y	gettext	')
    run_command_2('yum install -y	gettext-libs	')
    run_command_2('yum install -y	glib2	')
    run_command_2('yum install -y	gobject-introspection	')
    run_command_2('yum install -y	gsettings-desktop-schemas	')
    run_command_2('yum install -y	keyutils-libs	')
    run_command_2('yum install -y	kpartx	')
    run_command_2('yum install -y	krb5-libs	')
    run_command_2('yum install -y	libdrm	')
    run_command_2('yum install -y	libgudev1	')
    run_command_2('yum install -y	libnl3	')
    run_command_2('yum install -y	libnl3-cli	')
    run_command_2('yum install -y	libproxy	')
    run_command_2('yum install -y	libselinux	')
    run_command_2('yum install -y	libselinux-python	')
    run_command_2('yum install -y	libselinux-utils	')
    run_command_2('yum install -y	libsemanage	')
    run_command_2('yum install -y	libsepol	')
    run_command_2('yum install -y	libsoup	')
    run_command_2('yum install -y	libverto	')
    run_command_2('yum install -y	libxml2	')
    run_command_2('yum install -y	lvm2	')
    run_command_2('yum install -y	lvm2-libs	')
    run_command_2('yum install -y	openssl	')
    run_command_2('yum install -y	openssl-libs	')
    run_command_2('yum install -y	pciutils-libs	')
    run_command_2('yum install -y	pinentry	')
    run_command_2('yum install -y	policycoreutils	')
    run_command_2('yum install -y	selinux-policy	')
    run_command_2('yum install -y	systemd	')
    run_command_2('yum install -y	systemd-libs	')
    run_command_2('yum install -y	systemd-sysv	')
    run_command_2('yum install -y	tcp_wrappers-libs	')
    run_command_2('yum install -y	gnome-boxes	')

def groupinstall_font():
    # 安装groupinstall font
    run_command_2('yum install -y	cjkuni-uming-fonts	')
    run_command_2('yum install -y	dejavu-sans-fonts	')
    run_command_2('yum install -y	dejavu-sans-mono-fonts	')
    run_command_2('yum install -y	dejavu-serif-fonts   	')
    run_command_2('yum install -y	gnu-free-mono-fonts	')
    run_command_2('yum install -y	gnu-free-sans-fonts	')
    run_command_2('yum install -y	gnu-free-serif-fonts	')
    run_command_2('yum install -y	google-crosextra-caladea-fonts	')
    run_command_2('yum install -y	google-crosextra-carlito-fonts	')
    run_command_2('yum install -y	google-noto-emoji-fonts	')
    run_command_2('yum install -y	jomolhari-fonts	')
    run_command_2('yum install -y	khmeros-base-fonts	')
    run_command_2('yum install -y	liberation-mono-fonts	')
    run_command_2('yum install -y	liberation-sans-fonts	')
    run_command_2('yum install -y	liberation-serif-fonts	')
    run_command_2('yum install -y	lklug-fonts	')
    run_command_2('yum install -y	lohit-assamese-fonts	')
    run_command_2('yum install -y	lohit-bengali-fonts	')
    run_command_2('yum install -y	lohit-devanagari-fonts	')
    run_command_2('yum install -y	lohit-gujarati-fonts	')
    run_command_2('yum install -y	lohit-kannada-fonts	')
    run_command_2('yum install -y	lohit-malayalam-fonts	')
    run_command_2('yum install -y	lohit-marathi-fonts	')
    run_command_2('yum install -y	lohit-nepali-fonts	')
    run_command_2('yum install -y	lohit-oriya-fonts	')
    run_command_2('yum install -y	lohit-punjabi-fonts	')
    run_command_2('yum install -y	lohit-tamil-fonts	')
    run_command_2('yum install -y	lohit-telugu-fonts	')
    run_command_2('yum install -y	madan-fonts	')
    run_command_2('yum install -y	nhn-nanum-gothic-fonts	')
    run_command_2('yum install -y	open-sans-fonts	')
    run_command_2('yum install -y	overpass-fonts	')
    run_command_2('yum install -y	paktype-naskh-basic-fonts	')
    run_command_2('yum install -y	paratype-pt-sans-fonts	')
    run_command_2('yum install -y	sil-abyssinica-fonts	')
    run_command_2('yum install -y	sil-nuosu-fonts	')
    run_command_2('yum install -y	sil-padauk-fonts	')
    run_command_2('yum install -y	smc-meera-fonts	')
    run_command_2('yum install -y	stix-fonts	')
    run_command_2('yum install -y	thai-scalable-waree-fonts	')
    run_command_2('yum install -y	ucs-miscfixed-fonts	')
    run_command_2('yum install -y	vlgothic-fonts	')
    run_command_2('yum install -y	wqy-microhei-fonts	')
    run_command_2('yum install -y	wqy-zenhei-fonts	')
    run_command_2('yum install -y	dejavu-fonts-common	')
    run_command_2('yum install -y	fontpackages-filesystem	')
    run_command_2('yum install -y	gnu-free-fonts-common	')
    run_command_2('yum install -y	khmeros-fonts-common	')
    run_command_2('yum install -y	liberation-fonts-common	')
    run_command_2('yum install -y	nhn-nanum-fonts-common	')
    run_command_2('yum install -y	smc-fonts-common	')
    run_command_2('yum install -y	thai-scalable-fonts-common	')

def main70(repo_content):
    repo_content = repo_content.replace('_', '=')
    repo_content = base64.b64decode(repo_content).decode('utf-8')
    uuidfilename = uuid.uuid4().hex
    local_repo_file_path = '/root/' + uuidfilename + '.repo'
    with open(local_repo_file_path, 'w') as file:
        file.write(repo_content)
    if not os.path.exists(realtek_driver_file_path):
        with open(realtek_driver_file_path, 'w') as file:
            file.write(config_realtek_driver)
    with settings(hide('warnings', 'output')):
        run_command_1('mv /etc/yum.repos.d/* /root/')
        upload_file(f"{local_repo_file_path}", f"{ssh_repo_file_path}")

        # 获取当前内核版本 方便后续卸载
        result = run('uname -r')
        kernel_version = result.stdout

        run_command_1('yum makecache')
        run_command_1('setenforce 0')
        run_command_2('yum install yum-utils -y')
        run_command_1('yumdownloader filesystem  --destdir=/root/')
        run_command_1('rpm -Uvh /root/filesystem*')
        run_command_1('rpm -e centos-release --nodeps')
        run_command_1('rpm -e gnome-classic-session --nodeps')
        run_command_1('rpm -e gnome-initial-setup --nodeps')
        run_command_1('rpm -e gnome-shell-extension-alternate-tab --nodeps')
        run_command_1('rpm -e gnome-shell-extension-places-menu --nodeps ')
        run_command_1('rpm -e gnome-shell-extension-launch-new-instance --nodeps ')
        run_command_1('rpm -e gnome-shell-extension-window-list --nodeps')

        run_command_1('mv /etc/yum.repos.d/NFS-4.0-Base.repo /root/')
        run_command_2('yum update -y')
        run_command_1('mv /etc/yum.repos.d/NFS-4.0-Base.repo /root/')
        run_command_1(f'rpm -e kernel-{kernel_version} --nodeps')
        run_command_1(f'rpm -e kernel-devel-{kernel_version} --nodeps')
        run_command_1(f'rpm -e kernel-core-{kernel_version} --nodeps')
        run_command_1('grub2-mkconfig -o /boot/grub2/grub.cfg')
        run_command_1('grub2-mkconfig -o /boot/efi/EFI/NFS/grub.cfg')
        run_command_1('rpm -e centos-logos  --nodeps')
        run_command_2('yum install nfs-logos -y')
        run_command_2('yum install nfs-indexhtml -y')
        #run_command_1('yum groupinstall gnome -y')
        #run_command_1('yum install gnome-shell-extension-dash-to-panel -y')
        #run_command_1('yum install xorg-x11-server-common -y')
        #run_command_1('yum install xorg-x11-server-Xorg -y')
        #run_command_1('yum install xorg-x11-drv-* -y')
        #run_command_1('yum groupinstall font -y')
        #run_command_1('systemctl set-default graphical.target')
        #run_command_1('systemctl enable gdm')
        run_command_2('yum install kernel-headers -y')
        run_command_2('yum install kernel-devel -y')
        run_command_2('yum install kmod* -y')
        upload_file(f"{realtek_driver_file_path}",
                    "/etc/systemd/system/")
        run_command_1('systemctl enable load-realtek-driver.service')
        run_command_1('mv /root/NFS-4.0-Base.repo /etc/yum.repos.d/')
        local(f'rm -rf {local_repo_file_path}')
        run_command_1(f'rm -rf {ssh_repo_file_path}/{uuidfilename}.repo')
        run_command_1('echo 迁移完成！')


def main71_75(repo_content):
    repo_content = repo_content.replace('_', '=')
    repo_content = base64.b64decode(repo_content).decode('utf-8')
    uuidfilename = uuid.uuid4().hex
    local_repo_file_path = '/root/' + uuidfilename + '.repo'
    with open(local_repo_file_path, 'w') as file:
        file.write(repo_content)
    if not os.path.exists(realtek_driver_file_path):
        with open(realtek_driver_file_path, 'w') as file:
            file.write(config_realtek_driver)
    with settings(hide('warnings', 'output')):
        run_command_1('mv /etc/yum.repos.d/* /root/')
        upload_file(f"{local_repo_file_path}", f"{ssh_repo_file_path}")

        # 获取当前内核版本 方便后续卸载
        result = run('uname -r')
        kernel_version = result.stdout

        run_command_2('yum -y install yum-utils')

        run_command_1('yum clean all')
        run_command_1('yum makecache')
        run_command_1('mv /etc/yum.repos.d/NFS-4.0-Base.repo /root/')
        # 卸载剩余centos软件包
        run_command_1('rpm -e centos-release --nodeps')
        run_command_1('rpm -e centos-logos --nodeps')
        run_command_1('yumdownloader filesystem --destdir=/root/')
        run_command_1('rpm -Uvh /root/filesystem* ')
        run_command_1('yumdownloader samba-common --destdir=/root/')
        run_command_1('rpm -Uvh /root/samba-common* --nodeps')
        run_command_1('rpm -e python-inotify  --nodeps')
        run_command_1('rpm -e man-pages-zh-CN  --nodeps')
        run_command_1('rpm -e adwaita-qt5 --nodeps')
        run_command_1('rpm -e pycairo --nodeps')
        run_command_1('rpm -e gnome-classic-session --nodeps')
        run_command_1('rpm -e gnome-initial-setup --nodeps')
        run_command_1('rpm -e gnome-shell-extension-alternate-tab --nodeps')
        run_command_1('rpm -e gnome-shell-extension-places-menu --nodeps ')
        run_command_1('rpm -e gnome-shell-extension-launch-new-instance --nodeps ')
        run_command_1('rpm -e gnome-shell-extension-window-list --nodeps')
        run_command_1('rpm -e ipa-python --nodeps')
        # 卸载原有内核
        run_command_1('setenforce 0')
        run_command_2('yum update -y')
        run_command_1(f'rpm -e kernel-{kernel_version} --nodeps')
        run_command_1(f'rpm -e kernel-devel-{kernel_version} --nodeps')
        run_command_1(f'rpm -e kernel-core-{kernel_version} --nodeps')
        run_command_1('mv /etc/yum.repos.d/NFS-4.0-Base.repo /root/')
        run_command_1('rpm -e centos-indexhtml --nodeps')
        run_command_1('rpm -e gnome-backgrounds --nodeps')
        run_command_2('yum install nfs-logos -y')
        run_command_2('yum install nfs-release -y')
        run_command_1('grub2-mkconfig -o /boot/grub2/grub.cfg')
        run_command_1('grub2-mkconfig -o /boot/efi/EFI/NFS/grub.cfg')
        # 安装gnome图形界面
        #run_command_1('mv /etc/yum.repos.d/NFS-4.0-Base.repo /root/')
        #run_command_1('yum groupinstall gnome -y')
        #run_command_1('yum install xorg-x11-server-common -y')
        #run_command_1('yum install xorg-x11-server-Xorg -y')
        #run_command_1('yum install xorg-x11-drv-* -y')
        #run_command_1('yum groupinstall font -y')
        #run_command_1('systemctl set-default graphical.target')
        #run_command_1('systemctl enable gdm')
        run_command_2('yum install kernel-headers -y')
        run_command_2('yum install kernel-devel -y')
        run_command_2('yum install kmod* -y')
        upload_file(f"{realtek_driver_file_path}",
                    "/etc/systemd/system/")
        run_command_1('systemctl enable load-realtek-driver.service')
        run_command_1('mv /root/NFS-4.0-Base.repo /etc/yum.repos.d/')
        local(f'rm -rf {local_repo_file_path}')
        run_command_1(f'rm -rf {ssh_repo_file_path}/{uuidfilename}.repo')
        run_command_1('echo 迁移完成！')


def main76(repo_content):
    repo_content = repo_content.replace('_', '=')
    repo_content = base64.b64decode(repo_content).decode('utf-8')
    uuidfilename = uuid.uuid4().hex
    local_repo_file_path = '/root/' + uuidfilename + '.repo'
    with open(local_repo_file_path, 'w') as file:
        file.write(repo_content)
    if not os.path.exists(realtek_driver_file_path):
        with open(realtek_driver_file_path, 'w') as file:
            file.write(config_realtek_driver)
    with settings(hide('warnings', 'output')):
        run_command_1('mv /etc/yum.repos.d/* /root/')
        upload_file(f"{local_repo_file_path}", f"{ssh_repo_file_path}")

        run_command_1('ps -ef|grep "PackageKit" |grep -v |grep |awk"{print $2}"|xargs kill -9')
        # 获取当前内核版本 方便后续卸载
        result = run('uname -r')
        kernel_version = result.stdout

        run_command_2('yum -y install yum-utils')

        run_command_1('yum clean all')
        run_command_1('yum makecache')
        run_command_1('mv /etc/yum.repos.d/NFS-4.0-Base.repo /root/')
        # 卸载剩余centos软件包
        run_command_1('rpm -e centos-release --nodeps')
        run_command_1('rpm -e centos-logos --nodeps')
        run_command_1('yumdownloader filesystem --destdir=/root/')
        run_command_1('rpm -Uvh /root/filesystem* ')
        # 卸载原有内核
        run_command_1('setenforce 0')
        run_command_2('yum install nfs-logos -y')
        run_command_2('yum install nfs-release -y')
        run_command_1('mv /etc/yum.repos.d/NFS-4.0-Base.repo /root/')
        run_command_2('yum update -y')
        run_command_1(f'rpm -e kernel-{kernel_version} --nodeps')
        run_command_1(f'rpm -e kernel-devel-{kernel_version} --nodeps')
        run_command_1(f'rpm -e kernel-core-{kernel_version} --nodeps')
        run_command_1('grub2-mkconfig -o /boot/grub2/grub.cfg')
        run_command_1('grub2-mkconfig -o /boot/efi/EFI/NFS/grub.cfg')
        # 安装gnome图形界面
        #run_command_1('mv /etc/yum.repos.d/NFS-4.0-Base.repo /root/')
        #run_command_1('yum groupinstall gnome -y')
        #run_command_1('yum install xorg-x11-server-common -y')
        #run_command_1('yum install xorg-x11-server-Xorg -y')
        #run_command_1('yum install xorg-x11-drv-* -y')
        #run_command_1('yum groupinstall font -y')
        #run_command_1('systemctl set-default graphical.target')
        #run_command_1('systemctl enable gdm')
        #run_command_1('mv /root/NFS-4.0-Base.repo /etc/yum.repos.d/')
        run_command_2('yum install kernel-headers -y')
        run_command_2('yum install kernel-devel -y')
        run_command_2('yum install kmod* -y')
        upload_file(f"{realtek_driver_file_path}",
                    "/etc/systemd/system/")
        run_command_1('systemctl enable load-realtek-driver.service')
        local(f'rm -rf {local_repo_file_path}')
        run_command_1(f'rm -rf {ssh_repo_file_path}/{uuidfilename}.repo')
        run_command_1('echo 迁移完成！')


def main77_79(repo_content):
    repo_content = repo_content.replace('_', '=')
    repo_content = base64.b64decode(repo_content).decode('utf-8')
    uuidfilename = uuid.uuid4().hex
    local_repo_file_path = '/root/' + uuidfilename + '.repo'
    with open(local_repo_file_path, 'w') as file:
        file.write(repo_content) 
    if not os.path.exists(local_seconfig_file_path):
        with open(local_seconfig_file_path, 'w') as file:
            file.write(config_content)
    if not os.path.exists(realtek_driver_file_path):
        with open(realtek_driver_file_path, 'w') as file:
            file.write(config_realtek_driver)
    with settings(hide('warnings', 'output')):
        run_command_1('ps -ef|grep "PackageKit" |grep -v |grep |awk"{print $2}"|xargs kill -9')
        upload_file("/opt/nfs_migration_v2/backend/lixian_char.tar.gz", "/root")
        run_command_1('tar -xvf /root/lixian_char.tar.gz')
        run_command_1('rpm -Uvh /root/lixian_char/*.rpm --nodeps --force')
        run_command_1('mv /etc/yum.repos.d/* /root/')
        upload_file(f"{local_repo_file_path}", f"{ssh_repo_file_path}")

        run_command_1('yum clean all')
        run_command_1('yum makecache')
        run_command_1('rpm -e sysvinit-tools --nodeps')
        run_command_1('rpm -e mariadb-server --nodeps ')
        run_command_1('rpm -e mariadb --nodeps ')
        run_command_1('rpm -e mariadb-libs --nodeps ')
        run_command_1('mv /etc/yum /root/')
        run_command_2('dnf -y --allowerasing --setopt=deltarpm=false distro-sync --nogpgcheck ')
        #添加配置引导菜单
        run_command_1('grub2-mkconfig -o /boot/grub2/grub.cfg')
        run_command_1('grub2-mkconfig -o /boot/efi/EFI/NFS/grub.cfg')
        run_command_1('rpm -e centos-release --nodeps')
        run_command_1('rpm -e centos-logos --nodeps')
        run_command_2('yum install nfs-release -y')
        run_command_1('mv /etc/yum.repos.d/Nfs-Base.repo  /root/ ')
        run_command_1('mv /etc/yum.repos.d/Nfs-Media.repo /root/')
        # 安装gnome图形界面
        #run_command_1('yum install gdm -y')
        #run_command_1('yum install gnome-common -y')
        #run_command_1('yum install gnome-menus -y')
        #run_command_1('yum install gnome-terminal -y')
        #run_command_1('yum install gnome-shell-extension-dash-to-panel.noarch -y')
        #run_command_1('yum install nemo -y')
        #run_command_1('yum install gnome-shell-extension-apps-menu.noarch -y')
        #修复网络和ssh断开连接问题
        run_command_1('cp /etc/firewalld/firewalld.conf /etc/firewalld/firewalld.conf.backup')
        run_command_1("sed -i 's/IndividualCalls=no/IndividualCalls=yes/g' /etc/firewalld/firewalld.conf")
        run_command_1('systemctl restart firewalld')
        run_command_1("sed -i 's/#PermitRootLogin yes/PermitRootLogin yes/g' /etc/ssh/sshd_config")
        run_command_1('chmod 0600 /etc/ssh/ssh_host_rsa_key ')
        run_command_1('chmod 0600 /etc/ssh/ssh_host_ecdsa_key ')
        run_command_1('chmod 0600 /etc/ssh/ssh_host_ed25519_key')
        run_command_1('systemctl restart sshd')
        run_command_2('yum remove rsyslog -y')
        run_command_2('yum install rsyslog -y')
        run_command_2('systemctl restart rsyslog')
        #groupinstall_font()
        #groupinstall_gnome()
        #run_command_1('systemctl set-default graphical')
        #run_command_1('systemctl enable gdm')
        run_command_2('yum install kernel-headers -y')
        run_command_2('yum install kernel-devel -y')
        run_command_2('yum install kmod* -y')
        run_command_2('yum install mariadb -y')
        upload_file(f"{realtek_driver_file_path}",
                    "/etc/systemd/system/")
        run_command_1('systemctl enable load-realtek-driver.service')
        run_command_1('rm -rf /boot/loader/entries/*-0-rescue.conf')
        run_command_1('rm -rf /boot/loader/entries/*.el7.x86_64.conf')
        run_command_1('mv /root/Nfs-Base.repo /etc/yum.repos.d/')
        run_command_1('mv /root/Nfs-Media.repo /etc/yum.repos.d/')
        upload_file(f"{local_seconfig_file_path}",
                    "/etc/selinux/")  # 注意需要检测一下执行机器的selinux的配置文件确定disable，或准备一个已经永久关闭selinux的配置文件上传
        local(f'rm -rf {local_repo_file_path}')
        run_command_1(f'rm -rf {ssh_repo_file_path}/{uuidfilename}.repo')
        run_command_1('chmod 0600 /etc/ssh/ssh_host_rsa_key ')
        run_command_1('chmod 0600 /etc/ssh/ssh_host_ecdsa_key ')
        run_command_1('chmod 0600 /etc/ssh/ssh_host_ed25519_key')
        run_command_1('systemctl restart sshd')
        run_command_1('echo 迁移完成！')


def main80_85(repo_content):
    # 更新远程镜像源
    repo_content = repo_content.replace('_', '=')
    repo_content = base64.b64decode(repo_content).decode('utf-8')
    uuidfilename = uuid.uuid4().hex
    local_repo_file_path = '/root/' + uuidfilename + '.repo'
    with open(local_repo_file_path, 'w') as file:
        file.write(repo_content)
    if not os.path.exists(local_seconfig_file_path):
        with open(local_seconfig_file_path, 'w') as file:
            file.write(config_content)
    with settings(hide('warnings', 'output')):
        run_command_1('mv /etc/yum.repos.d/* /root/')
        upload_file(f"{local_repo_file_path}", f"{ssh_repo_file_path}")
        run_command_1('yum clean all')
        run_command_1('yum makecache')
        # 获取当前内核版本 方便后续卸载
        result = run('uname -r')
        kernel_version = result.stdout

        # 关闭一些服务,提前安装一些软件包确保不影响升级
        run_command_1('setenforce 0')
        run_command_1('kill -TERM 1')
        run_command_1('rpm -e centos-indexhtml --nodeps')
        run_command_2('yum install yum-utils -y')
        run_command_1('yumdownloader kmod-kvdo  --destdir=/root/')
        run_command_1('rpm -Uvh /root/kmod-kvdo* --nodeps')
        run_command_2('yum update dnf -y')
        run_command_1('yumdownloader filesystem  --destdir=/root/')
        run_command_1('rpm -Uvh /root/filesystem* ')
        run_command_1('rpm -e centos-linux-release --nodeps')
        run_command_1('rpm -e centos-linux-repos --nodeps')
        run_command_1('rpm -e centos-gpg-keys --nodeps')
        run_command_1('rpm -e centos-logos --nodeps')
        run_command_1('rpm -e centos-backgrounds --nodeps')
        run_command_1('rpm -e centos-logos-httpd --nodeps')
        # 开始升级
        run_command_2('dnf -y  --allowerasing --setopt=deltarpm=false distro-sync --nogpgcheck')

        # 卸载剩余centos软件包
        run_command_1('rpm --rebuilddb')
        run_command_1(f'rpm -e kernel-{kernel_version} --nodeps')
        run_command_1(f'rpm -e kernel-core-{kernel_version} --nodeps')
        run_command_1(f'rpm -e kernel-modules-{kernel_version} --nodeps')
        run_command_1('grub2-mkconfig -o /boot/grub2/grub.cfg')
        run_command_1('grub2-mkconfig -o /boot/efi/EFI/NFS/grub.cfg')

        # 安装NFS系列图形界面
        #run_command_1('yum install nfs-logos -y')
        #run_command_1('yum install nfs-backgrounds -y')
        #run_command_1('yum groupinstall gnome -y')
        #run_command_1('yum install gnome-* -y')
        #run_command_1('yum install nemo -y')
        #run_command_1('yum install xorg-x11-server-common -y')
        #run_command_1('yum install xorg-x11-server-Xorg -y')
        #run_command_1('yum install xorg-x11-drv-* -y')
        run_command_2('yum install kernel-headers -y')
        run_command_2('yum install kernel-devel -y')
        run_command_2('yum install kmod* -y')
        run_command_2('yum install nfs-release -y')

        # 设置图形界面显示生效
        run_command_1('kill -TERM 1')
        #run_command_1('systemctl set-default graphical.target')
        #run_command_1('systemctl enable gdm')
        run_command_1('rm -rf /boot/loader/entries/*-0-rescue.conf')
        run_command_1('rm -rf /boot/loader/entries/*.el8.x86_64.conf')
        run_command_1('mv /etc/selinux/config /root/')
        upload_file(f"{local_seconfig_file_path}",
                    "/etc/selinux/")  # 注意需要检测一下执行机器的selinux的配置文件确定disable，或准备一个已经永久关闭selinux的配置文件上传
        local(f'rm -rf {local_repo_file_path}')
        run_command_1(f'rm -rf {ssh_repo_file_path}/{uuidfilename}.repo')
        run_command_1('echo 迁移完成！')
