from datetime import datetime

from paramiko.ssh_exception import AuthenticationException

from utils.util import RemoteExec


def get_datetime_now():
    return datetime.now().strftime('%Y-%m-%d %H:%M:%S')


def check_account(remote):
    """
    检查账号登录情况
    """
    ip, port, username, password = remote
    is_success, msg = True, '成功'
    try:
        with RemoteExec(ip=ip, port=port, username=username, password=password) as ssh:
            out = ssh.exec(f'cat /etc/passwd | grep "{username}:x:0:"')
            if not out:
                is_success, msg = False, f"{ip} 没有最高权限,需要用户/etc/passwd {username}:x:0:"
    except:
        is_success, msg = False, f"{ip} {username}登录不成功"
    return is_success, msg


def check_repo(remote, repo_content):
    """
    检查repo是否可用
    """
    ip, port, username, password = remote
    is_success, msg = True, '成功'
    with RemoteExec(ip=ip, port=port, username=username, password=password) as ssh:
        baseurls = [i.replace(' ', '').split('=')[-1] for i in repo_content.split('\n') if 'baseurl' in i]
        for baseurl in baseurls:
            if ssh.exec(f"curl -I {baseurl} 2>&1 | grep OK"):
                continue
            is_success, msg = False, 'repo仓库不可用'
            break
    return is_success, msg


# remote = ("60.10.10.137", 1007, "root", "root")
# repo_content = """
# [nfs]
# name=nfs
# baseurl=http://60.10.20.184:90/nfs/
# enabled=1
# gpgcheck=0
# priority=1
# """
# print(check_repo(remote, repo_content))

def check_gz(remote, path_gz):
    """
    检查迁移文件是否上传
    """
    ip, port, username, password = remote
    is_success, msg = True, '成功'
    with RemoteExec(ip=ip, port=port, username=username, password=password) as ssh:
        if 'No such' in ssh.exec(f'ls {path_gz}'):
            is_success, msg = False, f'{path_gz}文件未发现'
        if 'no' in ssh.exec('which tar'):
            is_success, msg = False, '缺失tar命令，请安装'
    return is_success, msg

# remote = ("60.10.10.137", 1007, "root", "root")
# print(check_gz(remote, path_gz))
