import os
import re
import shutil

from utils.util import RemoteExec

centos_core_70 = ['audit', 'basesystem', 'bash', 'biosdevname', 'btrfs-progs', 'coreutils', 'cronie', 'curl', 'dhclient', 'e2fsprogs', 'filesystem', 'glibc', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iptables', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'plymouth', 'policycoreutils', 'procps-ng', 'rootfiles', 'rpm', 'rsyslog', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sudo', 'systemd', 'tar', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager', 'NetworkManager-tui', 'aic94xx-firmware', 'alsa-firmware', 'bfa-firmware', 'dracut-config-rescue', 'ivtv-firmware', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl3945-firmware', 'iwl4965-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6000g2b-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'kernel-tools', 'libertas-sd8686-firmware', 'libertas-sd8787-firmware', 'libertas-usb8388-firmware', 'linux-firmware', 'microcode_ctl', 'postfix', 'ql2100-firmware', 'ql2200-firmware', 'ql23xx-firmware']
centos_core_71 = ['audit', 'basesystem', 'bash', 'biosdevname', 'btrfs-progs', 'coreutils', 'cronie', 'curl', 'dhclient', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iptables', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'plymouth', 'policycoreutils', 'procps-ng', 'rootfiles', 'rpm', 'rsyslog', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sudo', 'systemd', 'tar', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager', 'NetworkManager-team', 'NetworkManager-tui', 'aic94xx-firmware', 'alsa-firmware', 'bfa-firmware', 'dracut-config-rescue', 'ivtv-firmware', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl3945-firmware', 'iwl4965-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6000g2b-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'kernel-tools', 'libertas-sd8686-firmware', 'libertas-sd8787-firmware', 'libertas-usb8388-firmware', 'libsysfs', 'linux-firmware', 'microcode_ctl', 'postfix', 'ql2100-firmware', 'ql2200-firmware', 'ql23xx-firmware', 'rdma']
centos_core_72 = ['audit', 'basesystem', 'bash', 'biosdevname', 'btrfs-progs', 'coreutils', 'cronie', 'curl', 'dhclient', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iptables', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'plymouth', 'policycoreutils', 'procps-ng', 'rootfiles', 'rpm', 'rsyslog', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sudo', 'systemd', 'tar', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager', 'NetworkManager-team', 'NetworkManager-tui', 'aic94xx-firmware', 'alsa-firmware', 'bfa-firmware', 'dracut-config-rescue', 'ivtv-firmware', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl3945-firmware', 'iwl4965-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6000g2b-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'iwl7265-firmware', 'kernel-tools', 'libertas-sd8686-firmware', 'libertas-sd8787-firmware', 'libertas-usb8388-firmware', 'libsysfs', 'linux-firmware', 'microcode_ctl', 'postfix', 'ql2100-firmware', 'ql2200-firmware', 'ql23xx-firmware', 'rdma']
centos_core_73 = ['audit', 'basesystem', 'bash', 'biosdevname', 'btrfs-progs', 'coreutils', 'cronie', 'curl', 'dhclient', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iptables', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'plymouth', 'policycoreutils', 'procps-ng', 'rootfiles', 'rpm', 'rsyslog', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sudo', 'systemd', 'tar', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager', 'NetworkManager-team', 'NetworkManager-tui', 'NetworkManager-wifi', 'aic94xx-firmware', 'alsa-firmware', 'dracut-config-rescue', 'ivtv-firmware', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl3945-firmware', 'iwl4965-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6000g2b-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'iwl7265-firmware', 'kernel-tools', 'libsysfs', 'linux-firmware', 'microcode_ctl', 'postfix', 'rdma']
centos_core_74 = ['audit', 'basesystem', 'bash', 'btrfs-progs', 'coreutils', 'cronie', 'curl', 'dhclient', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iptables', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'plymouth', 'policycoreutils', 'procps-ng', 'rootfiles', 'rpm', 'rsyslog', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sudo', 'systemd', 'tar', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager', 'NetworkManager-team', 'NetworkManager-tui', 'NetworkManager-wifi', 'aic94xx-firmware', 'alsa-firmware', 'biosdevname', 'dracut-config-rescue', 'ivtv-firmware', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl3945-firmware', 'iwl4965-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6000g2b-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'iwl7265-firmware', 'kernel-tools', 'libsysfs', 'linux-firmware', 'microcode_ctl', 'postfix']
centos_core_75 = ['audit', 'basesystem', 'bash', 'btrfs-progs', 'coreutils', 'cronie', 'curl', 'dhclient', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iptables', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'plymouth', 'policycoreutils', 'procps-ng', 'rootfiles', 'rpm', 'rsyslog', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sudo', 'systemd', 'tar', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager', 'NetworkManager-team', 'NetworkManager-tui', 'aic94xx-firmware', 'alsa-firmware', 'biosdevname', 'dracut-config-rescue', 'ivtv-firmware', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl3945-firmware', 'iwl4965-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6000g2b-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'iwl7265-firmware', 'kernel-tools', 'libsysfs', 'linux-firmware', 'lshw', 'microcode_ctl', 'postfix', 'sg3_utils', 'sg3_utils-libs']
centos_core_76 = ['audit', 'basesystem', 'bash', 'btrfs-progs', 'coreutils', 'cronie', 'curl', 'dhclient', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iptables', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'plymouth', 'policycoreutils', 'procps-ng', 'rootfiles', 'rpm', 'rsyslog', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sudo', 'systemd', 'tar', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager', 'NetworkManager-team', 'NetworkManager-tui', 'aic94xx-firmware', 'alsa-firmware', 'biosdevname', 'dracut-config-rescue', 'ivtv-firmware', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl3945-firmware', 'iwl4965-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6000g2b-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'iwl7265-firmware', 'kernel-tools', 'libsysfs', 'linux-firmware', 'lshw', 'microcode_ctl', 'postfix', 'sg3_utils', 'sg3_utils-libs']
centos_core_77 = ['audit', 'basesystem', 'bash', 'btrfs-progs', 'coreutils', 'cronie', 'curl', 'dhclient', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iptables', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'plymouth', 'policycoreutils', 'procps-ng', 'rootfiles', 'rpm', 'rsyslog', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sudo', 'systemd', 'tar', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager', 'NetworkManager-team', 'NetworkManager-tui', 'aic94xx-firmware', 'alsa-firmware', 'biosdevname', 'dracut-config-rescue', 'ivtv-firmware', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl3945-firmware', 'iwl4965-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6000g2b-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'iwl7265-firmware', 'kernel-tools', 'libsysfs', 'linux-firmware', 'lshw', 'microcode_ctl', 'postfix', 'sg3_utils', 'sg3_utils-libs']
centos_core_78 = ['audit', 'basesystem', 'bash', 'btrfs-progs', 'coreutils', 'cronie', 'curl', 'dhclient', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iptables', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'plymouth', 'policycoreutils', 'procps-ng', 'rootfiles', 'rpm', 'rsyslog', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sudo', 'systemd', 'tar', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager', 'NetworkManager-team', 'NetworkManager-tui', 'aic94xx-firmware', 'alsa-firmware', 'biosdevname', 'dracut-config-rescue', 'ivtv-firmware', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl3945-firmware', 'iwl4965-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6000g2b-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'kernel-tools', 'libsysfs', 'linux-firmware', 'lshw', 'microcode_ctl', 'postfix', 'sg3_utils', 'sg3_utils-libs']
centos_core_79 = ['audit', 'basesystem', 'bash', 'btrfs-progs', 'coreutils', 'cronie', 'curl', 'dhclient', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iptables', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'plymouth', 'policycoreutils', 'procps-ng', 'rootfiles', 'rpm', 'rsyslog', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sudo', 'systemd', 'tar', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager', 'NetworkManager-team', 'NetworkManager-tui', 'aic94xx-firmware', 'alsa-firmware', 'biosdevname', 'dracut-config-rescue', 'ivtv-firmware', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl3945-firmware', 'iwl4965-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6000g2b-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'kernel-tools', 'libsysfs', 'linux-firmware', 'lshw', 'microcode_ctl', 'postfix', 'sg3_utils', 'sg3_utils-libs']
centos_core_80 = ['audit', 'basesystem', 'bash', 'coreutils', 'cronie', 'curl', 'dnf', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'grubby', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'policycoreutils', 'procps-ng', 'rng-tools', 'rootfiles', 'rpm', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sssd-common', 'sssd-kcm', 'sudo', 'systemd', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager', 'NetworkManager-team', 'NetworkManager-tui', 'authselect', 'biosdevname', 'dnf-plugins-core', 'dracut-config-rescue', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl3945-firmware', 'iwl4965-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'kernel-tools', 'libsysfs', 'linux-firmware', 'lshw', 'lsscsi', 'microcode_ctl', 'prefixdevname', 'sg3_utils', 'sg3_utils-libs']
centos_core_81 = ['audit', 'basesystem', 'bash', 'coreutils', 'cronie', 'curl', 'dnf', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'grubby', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'policycoreutils', 'procps-ng', 'rng-tools', 'rootfiles', 'rpm', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sssd-common', 'sssd-kcm', 'sudo', 'systemd', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager', 'NetworkManager-team', 'NetworkManager-tui', 'authselect', 'biosdevname', 'dnf-plugins-core', 'dracut-config-rescue', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl3945-firmware', 'iwl4965-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'kernel-tools', 'libsysfs', 'linux-firmware', 'lshw', 'lsscsi', 'microcode_ctl', 'prefixdevname', 'sg3_utils', 'sg3_utils-libs']
centos_core_82 = ['audit', 'basesystem', 'bash', 'coreutils', 'cronie', 'curl', 'dnf', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'grubby', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'policycoreutils', 'procps-ng', 'rng-tools', 'rootfiles', 'rpm', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sssd-common', 'sssd-kcm', 'sudo', 'systemd', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager', 'NetworkManager-team', 'NetworkManager-tui', 'authselect', 'biosdevname', 'dnf-plugins-core', 'dracut-config-rescue', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl3945-firmware', 'iwl4965-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'kernel-tools', 'libsysfs', 'linux-firmware', 'lshw', 'lsscsi', 'microcode_ctl', 'prefixdevname', 'sg3_utils', 'sg3_utils-libs']
centos_core_83 = ['NetworkManager', 'audit', 'basesystem', 'bash', 'coreutils', 'cronie', 'curl', 'dnf', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'grubby', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'policycoreutils', 'procps-ng', 'rng-tools', 'rootfiles', 'rpm', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sssd-common', 'sssd-kcm', 'sudo', 'systemd', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager-team', 'NetworkManager-tui', 'authselect', 'biosdevname', 'dnf-plugins-core', 'dracut-config-rescue', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'kernel-tools', 'libsysfs', 'linux-firmware', 'lshw', 'lsscsi', 'microcode_ctl', 'prefixdevname', 'sg3_utils', 'sg3_utils-libs']
centos_core_84 = ['NetworkManager', 'audit', 'basesystem', 'bash', 'coreutils', 'cronie', 'curl', 'dnf', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'grubby', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'policycoreutils', 'procps-ng', 'rootfiles', 'rpm', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sssd-common', 'sssd-kcm', 'sudo', 'systemd', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager-team', 'NetworkManager-tui', 'authselect', 'biosdevname', 'dnf-plugins-core', 'dracut-config-rescue', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'kernel-tools', 'libsysfs', 'linux-firmware', 'lshw', 'lsscsi', 'microcode_ctl', 'prefixdevname', 'sg3_utils', 'sg3_utils-libs']
centos_core_85 = ['NetworkManager', 'audit', 'basesystem', 'bash', 'coreutils', 'cronie', 'curl', 'dnf', 'e2fsprogs', 'filesystem', 'firewalld', 'glibc', 'grubby', 'hostname', 'initscripts', 'iproute', 'iprutils', 'iputils', 'irqbalance', 'kbd', 'kexec-tools', 'less', 'man-db', 'ncurses', 'openssh-clients', 'openssh-server', 'parted', 'passwd', 'policycoreutils', 'procps-ng', 'rootfiles', 'rpm', 'selinux-policy-targeted', 'setup', 'shadow-utils', 'sssd-common', 'sssd-kcm', 'sudo', 'systemd', 'tuned', 'util-linux', 'vim-minimal', 'xfsprogs', 'yum', 'NetworkManager-team', 'NetworkManager-tui', 'authselect', 'biosdevname', 'dnf-plugins-core', 'dracut-config-rescue', 'iwl100-firmware', 'iwl1000-firmware', 'iwl105-firmware', 'iwl135-firmware', 'iwl2000-firmware', 'iwl2030-firmware', 'iwl3160-firmware', 'iwl5000-firmware', 'iwl5150-firmware', 'iwl6000-firmware', 'iwl6000g2a-firmware', 'iwl6050-firmware', 'iwl7260-firmware', 'kernel-tools', 'libsysfs', 'linux-firmware', 'lshw', 'lsscsi', 'microcode_ctl', 'prefixdevname', 'sg3_utils', 'sg3_utils-libs']


def get_centos_core_list(centos_version):
    """
    获取centos各个版本的最小化安装必备的包
    """
    if centos_version == '7.0':
        return centos_core_70
    elif centos_version == '7.1':
        return centos_core_71
    elif centos_version == '7.2':
        return centos_core_72
    elif centos_version == '7.3':
        return centos_core_73
    elif centos_version == '7.4':
        return centos_core_74
    elif centos_version == '7.5':
        return centos_core_75
    elif centos_version == '7.6':
        return centos_core_76
    elif centos_version == '7.7':
        return centos_core_77
    elif centos_version == '7.8':
        return centos_core_78
    elif centos_version == '7.9':
        return centos_core_79
    elif centos_version == '8.0':
        return centos_core_80
    elif centos_version == '8.1':
        return centos_core_81
    elif centos_version == '8.2':
        return centos_core_82
    elif centos_version == '8.3':
        return centos_core_83
    elif centos_version == '8.4':
        return centos_core_84
    elif centos_version == '8.5':
        return centos_core_85
    else:
        return []


def get_centos_version(remote):
    centos_version = None
    ip, port, username, password = remote
    with RemoteExec(ip=ip, port=port, username=username, password=password) as ssh:
        out = ssh.exec('cat /etc/centos-release')
        pattern = r"release (\d+\.\d+)"
        match = re.search(pattern, out)
        if match:
            centos_version = match.group(1)
    return centos_version


def get_info(remote):
    ip, port, username, password = remote
    with RemoteExec(ip=ip, port=port, username=username, password=password) as ssh:
        system_name = ssh.exec('cat /etc/os-release | grep PRETTY_NAME | cut -d "=" -f2').strip('"')
        system_version = ssh.exec('cat /etc/os-release | grep SYSTEM_VERSION | cut -d "=" -f2').strip('"')
        kernel, schema = ssh.exec('uname -rm').rstrip('\n').split(' ')
        hostname = ssh.exec('hostname').rstrip('\n')
        installed_software_num = ssh.exec('rpm -qa | wc -l')
        cpu_model_name = ssh.exec('grep "model name" /proc/cpuinfo | head -n 1 | cut -d ":" -f 2 | xargs')
        cpu_totle_core_num = ssh.exec('grep -c "model name" /proc/cpuinfo')
        mem_totle_size = ssh.exec('free -h | grep "Mem:" | sed "s/\s\+/,/g" | cut -d"," -f2')
        swap_mem_totle_size = ssh.exec('free -h | grep "Swap:" | sed "s/\s\+/,/g" | cut -d"," -f2')
        yum_backup_path = ssh.exec('cat /etc/yum.conf | grep cachedir | cut -d "=" -f2')
        avail = ssh.exec(f'df -h {yum_backup_path}' + " | sed -n 2p | awk '{print $4}'")
    data = {"system_name": system_name, "system_version": system_version, "kernel": kernel, "schema": schema,
            "hostname": hostname, "installed_software_num": installed_software_num,
            "cpu_model_name": cpu_model_name, "cpu_totle_core_num": cpu_totle_core_num,
            "mem_totle_size": mem_totle_size, "swap_mem_totle_size": swap_mem_totle_size, "avail": avail}
    return data


def get_local(remote):
    ip, port, username, password = remote
    with RemoteExec(ip=ip, port=port, username=username, password=password) as ssh:
        rpms = ssh.exec('rpm -qa --qf "%{NAME} || %{VERSION} || %{RELEASE} || %{ARCH}\n"')
        res = {}
        for rpm in rpms.splitlines():
            rpm_info = {}
            rpm_info['name'], rpm_info['version'], rpm_info['release'], rpm_info['arch'] = rpm.split(' || ')
            res[rpm_info['name']] = rpm_info
    return res


def get_remote(remote, repo_content):
    ip, port, username, password = remote
    with RemoteExec(ip=ip, port=port, username=username, password=password) as ssh:
        ssh.exec(f'''cp -R /etc/yum.repos.d /etc/yum.repos.d.bak && rm -rf /etc/yum.repos.d/* ''')  # 备份repo
        ssh.file_a('/etc/yum.repos.d/switch-to-nfs.repo', repo_content, 'w')  # 写repo

        packages = ssh.exec(f"yum list")
        res = {}
        for package in packages.splitlines():
            package_info = {}
            try:
                name_arch, version_release, _ = package.split()
                if ':' in version_release:
                    version_release = ''.join(version_release.split(':')[1:])
                package_info['name'] = name_arch.split('.')[0]
                package_info['version'] = version_release.split('-')[0]
                package_info['release'] = ''.join(version_release.split('-')[1:])
                package_info['arch'] = ''.join(name_arch.split('.')[1:])
                res[package_info['name']] = package_info
            except:
                pass

        ssh.exec('rm -rf /etc/yum.repos.d && mv /etc/yum.repos.d.bak /etc/yum.repos.d/')  # 还原repo
    return res


def get_config(remote):
    '''
 1）启动项配置：cat /boot/config-$(uname -r)
 2）系统环境变量;printenv
 3）系统参数：sysctl -a
 4）内核模块:lsmod
 5）系统命令：compgen -c，参考第二页第一列
 6）开机自启：systemctl list-unit-files --type=service | grep enabled
 7）定时任务：crontab -l
 8）防火墙配置：cat /etc/sysconfig/iptables-config
    '''
    ip, port, username, password = remote
    with RemoteExec(ip=ip, port=port, username=username, password=password) as ssh:
        res = {}
        res['boot'] = ssh.exec('cat /boot/config-$(uname -r)')
        res['env'] = ssh.exec('printenv')
        res['sysctl'] = ssh.exec('sysctl -a')
        res['lsmod'] = ssh.exec('lsmod')
        res['compgen'] = ssh.exec('compgen -c')
        res['enabled'] = ssh.exec('systemctl list-unit-files --type=service | grep enabled')
        res['crontab'] = ssh.exec('crontab -l')
        res['iptables'] = ssh.exec('cat /etc/sysconfig/iptables-config')
        res['network'] = ssh.exec('ip a')
    return res


def check_abi(remote):
    '''
判断server上abi程序是否存在 /home/nfs_migration_abi.tar.gz
判断迁移机器上python3是否存在 which python3
判断迁移机器上pip3是否存在 which pip3
判断迁移机器上pip3是否存在 which tar
判断迁移机器上file-libs是否安装 rpm -qa | grep file-libs
判断迁移机器上file-devel是否安装 rpm -qa | grep file-devel
判断pip3中python-magic是否安装 pip3 list | grep python-magic
判断pip3中rpm==0.1.0是否安装 pip3 freeze | grep rpm==0.1.0
执行本地安装 rpm -ivh libabigail --nodeps
执行本地安装 rpm -ivh python3-rpm --nodeps
    '''
    ip, port, username, password = remote
    is_success, msg = True, '成功'
    errors = []
    if not os.path.exists('/home/nfs_migration_abi.tar.gz'):
        errors.append('未发现/home/nfs_migration_abi.tar.gz')
    with RemoteExec(ip=ip, port=port, username=username, password=password) as ssh:
        if 'no' in ssh.exec('which python3'):
            errors.append('未安装python3')
        if 'no' in ssh.exec('which pip3'):
            errors.append('未安装pip3')
        else:
            if ssh.exec('pip3 list | grep python-magic') == '':
                errors.append('pip3中未安装python-magic')
            if ssh.exec('pip3 freeze | grep rpm==0.1.0') == '' and get_centos_version(remote) in ['7.7', '7.8', '7.9', '8.0', '8.1', '8.2', '8.3', '8.4', '8.5']:
                errors.append('pip3中未安装rpm==0.1.0')
        if 'no' in ssh.exec('which tar'):
            errors.append('未安装tar')
        if ssh.exec('rpm -qa | grep file-libs') == '':
            errors.append('未安装file-libs')
        if ssh.exec('rpm -qa | grep file-devel') == '':
            errors.append('未安装file-devel')
        if errors:
            is_success, msg = False, '\n'.join(errors)
        return is_success, msg
