import copy

from drf_yasg.inspectors import SwaggerAutoSchema


class CustomAutoSchema(SwaggerAutoSchema):

    def get_tags(self, operation_keys=None):
        operation_keys = operation_keys or self.operation_keys
        tags = self.overrides.get('tags')
        if not tags:
            tags = ["token"] if "token" in operation_keys else [self.view.route_label]
        return tags

    def get_operation_id(self, operation_keys=None):
        if not hasattr(self.view, "get_route"):
            return super().get_operation_id(operation_keys)
        _, route_method = copy.deepcopy(self.view.get_route())
        if hasattr(self.view, "route_method_allow"):
            route_method.update(self.view.route_method_allow)
        action = operation_keys[-1]
        if action == "read":
            action = "retrieve"
        if action == "delete":
            action = "destroy"
        return route_method.get(action, "废弃")

